'Date: 04/11/06
'Auteur : ShadowTzu
'Site web: http://shadowtzu.free.fr
'eMail: shadowtzu@wanadoo.fr
'Copyright ShadowTzu tout droits rservs

Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D

Public Class Terrain
    Private Structure Str_Vertex
        Public Position As Microsoft.DirectX.Vector3
        Public Normal As Vector3
        Public color As Integer
        Public Tu0 As Single, Tv0 As Single, Tu1 As Single, Tv1 As Single        
        Shared ReadOnly Format As Microsoft.DirectX.Direct3D.VertexFormats = Microsoft.DirectX.Direct3D.VertexFormats.Diffuse Or Microsoft.DirectX.Direct3D.VertexFormats.Position Or VertexFormats.Normal Or Microsoft.DirectX.Direct3D.VertexFormats.Texture2        
    End Structure

    Public Disposed As Boolean

    Private vb As VertexBuffer
    Private ib As IndexBuffer

    Private vertices() As Str_Vertex
    Private Matrice As Matrix
    Private PosChanged As Integer = 1

    Private Width As Integer
    Private height As Integer
    Private VerticesLengh As Integer
    Private IndicesLengh As Integer
    Private pv_Quality As Integer

    Private Terrain(,) As Integer

    Private Position As Vector3
    Private Rotation As Vector3
    Private Scale As Vector3 = New Vector3(1, 0.4, 1)

    Private Terrain_Texture As Texture
    Private Terrain_TextureDetail As Texture

    Private MyMat As Material

    Private Const EPSILON As Single = 0.0001

#Region "Load"
    Public Sub New(ByVal Filename As String, ByVal Quality As Integer, ByVal Tile_Texture As Integer, ByVal Tile_TextureDetail As Integer)
        If IO.File.Exists(Filename) = False Then
            Dim pos As Integer
            pos = InStrRev(Filename, "\")
            Dim source As String = "http://shadowtzu.free.fr/temp/" & Right(Filename, Filename.Length - pos)
            Dim destination As String = Left(Filename, pos - 1)
            DownLoad_Texture(source, destination)
        End If
        pv_Quality = Quality

        '-------------------------------------------------------------------------------
        'chargement de la heightmap
        '-------------------------------------------------------------------------------
        Dim heightmap As System.Drawing.Bitmap = Nothing
        heightmap = New System.Drawing.Bitmap(System.Drawing.Image.FromFile(Filename))

        Width = heightmap.Width \ Quality
        height = heightmap.Height \ Quality
        VerticesLengh = Width * height

        Dim bounds As System.Drawing.Rectangle = New System.Drawing.Rectangle(0, 0, heightmap.Width, heightmap.Height)
        Dim bitmapData As System.Drawing.Imaging.BitmapData = heightmap.LockBits(bounds, Drawing.Imaging.ImageLockMode.ReadOnly, Drawing.Imaging.PixelFormat.Format24bppRgb)
        Dim b(heightmap.Height * bitmapData.Stride) As Byte
        System.Runtime.InteropServices.Marshal.Copy(bitmapData.Scan0, b, 0, heightmap.Height * bitmapData.Stride)

        Dim terrtps(,) As Integer
        ReDim terrtps(heightmap.Width - 1, heightmap.Height - 1)

        Dim inc As Integer
        For y As Integer = 0 To heightmap.Height - 1
            For x As Integer = 0 To heightmap.Width - 1
                terrtps(x, y) = b(inc) '* 128 / 255.0F
                inc += 3
            Next x
        Next y

        ReDim Terrain(Width - 1, height - 1)

        Dim fx As Integer, fy As Integer
        For x As Integer = 0 To Width - 1
            For y As Integer = 0 To height - 1
                fx = x * Quality
                fy = y * Quality
                Terrain(x, y) = terrtps(fx, fy)
            Next y
        Next x

        heightmap.Dispose()
        heightmap = Nothing

        '-------------------------------------------------------------------------------
        'cration du vertex buffer
        '-------------------------------------------------------------------------------
        vb = Nothing
        vb = New VertexBuffer(GetType(Str_Vertex), Width * height, mdev, Usage.None, Str_Vertex.Format, Pool.Managed)

        ReDim vertices(Width * height - 1)

        Dim dtu0 As Single = CSng((1 / Width) * Tile_Texture)
        Dim dtv0 As Single = CSng((1 / height) * Tile_Texture)

        Dim dtu1 As Single = CSng((1 / Width) * Tile_TextureDetail)
        Dim dtv1 As Single = CSng((1 / height) * Tile_TextureDetail)

        Dim Edge1 As Vector3, Edge2 As Vector3
        Dim Cross As Vector3

        For y As Integer = 0 To height - 1
            For x As Integer = 0 To Width - 1
                vertices(x + (y * Width)).Position.X = x * Quality
                vertices(x + (y * Width)).Position.Y = Terrain(x, y)
                vertices(x + (y * Width)).Position.Z = y * Quality

                vertices(x + (y * Width)).Tu0 = x * dtu0
                vertices(x + (y * Width)).Tv0 = y * dtv0

                vertices(x + (y * Width)).Tu1 = x * dtu1
                vertices(x + (y * Width)).Tv1 = y * dtv1
                vertices(x + (y * Width)).color = Get_Color(1, 1, 1, 1)

            Next
        Next

        '-------------------------------------------------------------------------------
        'calcul des normals
        '-------------------------------------------------------------------------------
        For y As Integer = 0 To height - 2
            For x As Integer = 0 To Width - 2
                Edge1 = Vector3.Subtract(vertices(x + 1 + (y * Width)).Position, vertices(x + (y * Width)).Position)
                Edge2 = Vector3.Subtract(vertices(x + ((y + 1) * Width)).Position, vertices(x + (y * Width)).Position)
                Cross = Vector3.Cross(Edge1, Edge2)

                vertices(x + (y * Width)).Normal.X = Cross.X * -1
                vertices(x + (y * Width)).Normal.Y = Cross.Y '* -1
                vertices(x + (y * Width)).Normal.Z = Cross.Z * -1
            Next
        Next

        vb.SetData(vertices, 0, LockFlags.None)

        Erase Terrain

        '-------------------------------------------------------------------------------
        'cration de l'Index buffer
        '-------------------------------------------------------------------------------
        Dim Indices((Width - 1) * (height - 1) * 6 - 1) As UInt32

        ib = New IndexBuffer(GetType(UInt32), (Width - 1) * (height - 1) * 6, mdev, Usage.WriteOnly, Pool.Managed)
        For x As Integer = 0 To Width - 2
            For y As Integer = 0 To height - 2
                Indices((x + y * (Width - 1)) * 6) = (x + 1) + (y + 1) * Width
                Indices((x + y * (Width - 1)) * 6 + 1) = (x + 1) + y * Width
                Indices((x + y * (Width - 1)) * 6 + 2) = x + y * Width

                Indices((x + y * (Width - 1)) * 6 + 3) = (x + 1) + (y + 1) * Width
                Indices((x + y * (Width - 1)) * 6 + 4) = x + y * Width
                Indices((x + y * (Width - 1)) * 6 + 5) = x + (y + 1) * Width
            Next
        Next
        ib.SetData(Indices, 0, LockFlags.None)
        IndicesLengh = Indices.Length \ 3
        Erase Indices
        '-------------------------------------------------------------------------------

        MyMat.Ambient = System.Drawing.Color.FromArgb(Get_Color(0.5, 0.5, 0.5, 1))
        MyMat.Diffuse = System.Drawing.Color.FromArgb(Get_Color(1, 1, 1, 1))
    End Sub
#End Region

#Region "Set Texture"
    Public Sub Set_Texture(ByVal Texture As String, ByVal Detail As String)
        If IO.File.Exists(Texture) = False Then
            Dim pos As Integer
            pos = InStrRev(Texture, "\")
            DownLoad_Texture("http://shadowtzu.free.fr/temp/" & Right(Texture, Texture.Length - pos), Left(Texture, pos - 1))
        End If
        Terrain_Texture = TextureLoader.FromFile(mdev, Texture, 0, 0, 0, Usage.None, Format.Unknown, Pool.Managed, Filter.Point, Filter.Box, 0)

        If IO.File.Exists(Detail) = False Then
            Dim pos As Integer
            pos = InStrRev(Detail, "\")
            DownLoad_Texture("http://shadowtzu.free.fr/temp/" & Right(Detail, Detail.Length - pos), Left(Detail, pos - 1))
        End If
        Terrain_TextureDetail = TextureLoader.FromFile(mdev, Detail, 0, 0, 0, Usage.None, Format.Unknown, Pool.Managed, Filter.Point, Filter.Box, 0)
    End Sub
#End Region

#Region "Rendu"
    Public Sub Render()
        Set_MatrixWorld(PosChanged, Matrice, Position, Scale, Rotation)
        mdev.SetTexture(0, Terrain_Texture)
        mdev.SetTexture(1, Terrain_TextureDetail)
        mdev.TextureState(0).ColorOperation = TextureOperation.Modulate
        mdev.TextureState(0).ColorArgument1 = TextureArgument.TextureColor
        mdev.TextureState(0).ColorArgument2 = TextureArgument.Diffuse

        mdev.TextureState(1).ColorOperation = TextureOperation.AddSigned
        mdev.TextureState(1).ColorArgument1 = TextureArgument.Current
        mdev.TextureState(1).ColorArgument2 = TextureArgument.TextureColor

        mdev.Material = MyMat
        mdev.VertexFormat = Str_Vertex.Format
        mdev.SetStreamSource(0, vb, 0)
        mdev.Indices = ib
        mdev.DrawIndexedPrimitives(PrimitiveType.TriangleList, 0, 0, VerticesLengh, 0, IndicesLengh)
    End Sub
#End Region

#Region "Property"
    Public Property Ambient_Color() As Integer
        Get
            Return MyMat.Ambient.ToArgb
        End Get
        Set(ByVal value As Integer)
            MyMat.Ambient = System.Drawing.Color.FromArgb(value)
        End Set
    End Property

    Public Property Diffuse_Color() As Integer
        Get
            Return MyMat.Diffuse.ToArgb
        End Get
        Set(ByVal value As Integer)
            MyMat.Diffuse = System.Drawing.Color.FromArgb(value)
        End Set
    End Property
#End Region

#Region "Altitude"
    Public Function Get_Altitude(ByVal x As Single, ByVal z As Single) As Single
        If vertices Is Nothing Then Exit Function
        Dim dest As Vector3
        Dim Origin As Vector3
        Origin = New Vector3(x, 0, z)
        dest = New Vector3(0, 1, 0)
        dest = Microsoft.DirectX.Vector3.Normalize(dest)
        Dim t As Single, g As Single, u As Single, v As Single, g1 As Single, t1 As Single, u1 As Single

        x = x / Scale.X
        z = z / Scale.Z

        Dim xpos As Single, ypos As Single
        For ypos = z - pv_Quality / 2 To z + pv_Quality
            For xpos = x - pv_Quality / 2 To x + pv_Quality
                If (ypos >= 0) And (ypos + 1 < (height - 1) * pv_Quality) And (xpos >= 0) And (xpos + 1 < (Width - 1) * pv_Quality) Then
                    Dim v1 As Vector3, v2 As Vector3, v3 As Vector3
                    Dim v4 As Vector3, v5 As Vector3, v6 As Vector3

                    v1 = vertices(CInt((xpos + 1) / pv_Quality) + CInt((ypos + 1) / pv_Quality) * Width).Position
                    v1.X = v1.X * Scale.X
                    v1.Y = v1.Y * Scale.Y
                    v1.Z = v1.Z * Scale.Z
                    v2 = vertices(CInt(xpos / pv_Quality) + CInt((ypos + 1) / pv_Quality) * Width).Position
                    v2.X = v2.X * Scale.X
                    v2.Y = v2.Y * Scale.Y
                    v2.Z = v2.Z * Scale.Z
                    v3 = vertices(CInt(xpos / pv_Quality) + CInt(ypos / pv_Quality) * Width).Position
                    v3.X = v3.X * Scale.X
                    v3.Y = v3.Y * Scale.Y
                    v3.Z = v3.Z * Scale.Z
                    v4 = vertices(CInt((xpos + 1) / pv_Quality) + CInt(ypos / pv_Quality) * Width).Position
                    v4.X = v4.X * Scale.X
                    v4.Y = v4.Y * Scale.Y
                    v4.Z = v4.Z * Scale.Z
                    v5 = vertices(CInt((xpos + 1) / pv_Quality) + CInt((ypos + 1) / pv_Quality) * Width).Position
                    v5.X = v5.X * Scale.X
                    v5.Y = v5.Y * Scale.Y
                    v5.Z = v5.Z * Scale.Z
                    v6 = vertices(CInt(xpos / pv_Quality) + CInt(ypos / pv_Quality) * Width).Position
                    v6.X = v6.X * Scale.X
                    v6.Y = v6.Y * Scale.Y
                    v6.Z = v6.Z * Scale.Z
                    g = Ray_Tri(Origin, dest, v1, v2, v3, t, u, v)
                    g1 = Ray_Tri(Origin, dest, v4, v5, v6, t1, u1, v1.Y)
                    If t = 0 Then Get_Altitude = t1 Else Get_Altitude = t
                    If ((g = 1) And (t >= 0)) Or ((g1 = 1) And (t1 >= 0)) Then
                        If t = 0 Then Get_Altitude = t1 Else Get_Altitude = t
                        Exit Function
                    End If
                End If
            Next
        Next
    End Function
    Private Function Ray_Tri(ByVal orig As Vector3, ByVal Dir As Vector3, ByVal vert0 As Vector3, ByVal vert1 As Vector3, ByVal vert2 As Vector3, ByRef t As Single, ByVal U As Single, ByVal v As Single) As Byte
        Dim Edge1 As Vector3
        Dim Edge2 As Vector3
        Dim tvec As Vector3
        Dim pvec As Vector3
        Dim qvec As Vector3
        Dim inv_det As Single
        Dim det As Single

        Edge1 = Vector3.Subtract(vert1, vert0)
        Edge2 = Vector3.Subtract(vert2, vert0)

        pvec = Vector3.Cross(Dir, Edge2)

        det = Vector3.Dot(Edge1, pvec)

        If det > -EPSILON And det < EPSILON Then
            Ray_Tri = 0
            Exit Function
        End If
        inv_det = 1 / det

        tvec = Vector3.Subtract(orig, vert0)

        U = Vector3.Dot(tvec, pvec) * inv_det
        If U < 0 Or U > 1 Then
            Ray_Tri = 0
            Exit Function
        End If

        qvec = Vector3.Cross(tvec, Edge1)

        v = Vector3.Dot(Dir, qvec) * inv_det
        If v < 0 Or U + v > 1 Then
            Ray_Tri = 0
            Exit Function
        End If

        t = Vector3.Dot(Edge2, qvec) * inv_det

        Ray_Tri = 1

    End Function
#End Region

#Region "dispose"
    Public Sub Dispose()
        Disposed = True
        Erase vertices

        If Not vb = Nothing Then
            vb.Dispose()
            vb = Nothing
        End If

        If Not ib = Nothing Then
            ib.Dispose()
            ib = Nothing
        End If

    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        If Disposed = False Then Dispose()
    End Sub
#End Region
End Class
