'Date: 14/11/06
'Auteur : ShadowTzu
'Site web: http://shadowtzu.free.fr
'eMail: shadowtzu@wanadoo.fr
'Copyright ShadowTzu tout droits rservs

Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D
Public Class Mesh_static
    Public Disposed As Boolean
    Private Mon_Mesh As Mesh
    Dim Materiaux() As ExtendedMaterial = Nothing
    Dim NumX As Integer
    Dim Tex() As Texture
    Dim Mat() As Material
    Private Const vertexFormat As VertexFormats = CustomVertex.PositionNormalTextured.Format

    Private Matrice As Matrix
    Private pv_Position As Vector3
    Private pv_Rotation As Vector3
    Private pv_Scale As Vector3 = New Vector3(1, 1, 1)
    Private PosChanged As Integer = 1

    Dim adj As Integer()


    Public Sub New(ByVal Filename As String)
        If IO.File.Exists(Filename) = False Then
            Dim pos As Integer
            pos = InStrRev(Filename, "\")
            Dim source As String = "http://shadowtzu.free.fr/temp/" & Right(Filename, Filename.Length - pos)
            Dim destination As String = Left(Filename, pos - 1)
            Download(source, destination)
        End If

        Mon_Mesh = Nothing
        Mon_Mesh = Mesh.FromFile(Filename, MeshFlags.Managed, mdev, Materiaux)

        NumX = Materiaux.Length - 1
        ReDim Tex(NumX)
        ReDim Mat(NumX)

        Dim i As Integer
        For i = 0 To NumX
            Tex(i) = Nothing
            If Materiaux(i).TextureFilename <> "" Then
                Try
                    Dim ChemTex = Left(Filename, Len(Filename) - Len(Mid(Filename, InStrRev(Filename, "\")))) & "\" & Materiaux(i).TextureFilename
                    If IO.File.Exists(ChemTex) = False Then
                        Dim pos As Integer
                        pos = InStrRev(ChemTex, "\")
                        Dim source As String = "http://shadowtzu.free.fr/temp/" & Right(ChemTex, ChemTex.Length - pos)
                        Dim destination As String = Left(ChemTex, pos - 1)
                        Download(source, destination)
                    End If
                    Tex(i) = TextureLoader.FromFile(mdev, ChemTex)
                Catch ex As Exception
                End Try
            End If
            Mat(i) = Materiaux(i).Material3D
            Mat(i).Ambient = Mat(i).Diffuse

        Next

    End Sub


    Public Property Position() As Vector3
        Get
            Return pv_Position
        End Get
        Set(ByVal value As Vector3)
            pv_Position = value
            PosChanged = 1
        End Set
    End Property

    Public Property Rotation() As Vector3
        Get
            Return pv_Rotation
        End Get
        Set(ByVal value As Vector3)
            pv_Rotation = value
            PosChanged = 1
        End Set
    End Property
    Public Property Scale() As Vector3
        Get
            Return pv_Scale
        End Get
        Set(ByVal value As Vector3)
            pv_Scale = value
            PosChanged = 1
        End Set
    End Property

    Public Sub Render()

        Set_MatrixWorld(PosChanged, Matrice, pv_Position, pv_Scale, pv_Rotation)
        Dim i As Integer
        For i = 0 To NumX
            mdev.SetTexture(0, Tex(i))
            Mon_Mesh.DrawSubset(i)
        Next

    End Sub

    Public Sub Optimize()
        If Mon_Mesh Is Nothing Then Exit Sub
        If Mon_Mesh.VertexFormat <> CustomVertex.PositionNormalTextured.Format Then
            Mon_Mesh = Mon_Mesh.Clone(MeshFlags.Managed, vertexFormat, mdev)
            Mon_Mesh.ComputeNormals()
        End If
        adj = Mon_Mesh.ConvertPointRepsToAdjacency(CType(Nothing, GraphicsStream))
        Mon_Mesh.OptimizeInPlace(MeshFlags.OptimizeAttributeSort Or MeshFlags.OptimizeCompact Or MeshFlags.OptimizeVertexCache, adj)
    End Sub

    Private Sub Compute_Tangent()
        'If Mon_Mesh Is Nothing Then Exit Sub

        Dim vd As VertexDeclaration
        vd = BumpVertexD()
        Mon_Mesh = Mon_Mesh.Clone(MeshFlags.Managed, vd.GetDeclaration, mdev)
        Mon_Mesh.ComputeTangent(0, 2, 3, 1)
    End Sub

    Private Function BumpVertexD() As VertexDeclaration
        Dim element() As VertexElement = {New VertexElement(0, 0, DeclarationType.Float3, DeclarationMethod.Default, DeclarationUsage.Position, 0), New VertexElement(0, 12, DeclarationType.Float3, DeclarationMethod.Default, DeclarationUsage.Normal, 0), New VertexElement(0, 24, DeclarationType.Float2, DeclarationMethod.Default, DeclarationUsage.TextureCoordinate, 0), New VertexElement(0, 32, DeclarationType.Float2, DeclarationMethod.Default, DeclarationUsage.TextureCoordinate, 1), New VertexElement(0, 40, DeclarationType.Float3, DeclarationMethod.Default, DeclarationUsage.Tangent, 2), New VertexElement(0, 52, DeclarationType.Float3, DeclarationMethod.Default, DeclarationUsage.BiNormal, 3), VertexElement.VertexDeclarationEnd}
        Return New VertexDeclaration(mdev, element)
    End Function

    Public Sub Dispose()
        If Disposed = False Then Disposed = True
        If Not Mon_Mesh Is Nothing Then
            Mon_Mesh.Dispose()
            Mon_Mesh = Nothing
        End If

        Dim i As Integer
        For i = 0 To NumX
            Materiaux(i) = Nothing
            Mat(i) = Nothing
            Tex(i).Dispose()
            Tex(i) = Nothing
        Next

        Erase Materiaux
        Erase Mat
        Erase Tex
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        If Disposed = False Then Dispose()
    End Sub
End Class
